import pygame,pickle,sys,time,string,pygame.mixer
from pygame.locals import *
class animsprite:
	def __init__(self,picture,picture_size,picture_num,picture_space):
		self.pic=picture
		self.frame=0
		self.fnum=picture_num
		self.aspace=picture_size
		self.pspace=picture_space
		self.ltime=pygame.time.get_ticks()
		self.fdir=1
		self.np=0
	def animate(self,position,animation,target):
		if pygame.time.get_ticks()-self.ltime > self.pspace and self.fnum > 0:
			self.ltime=pygame.time.get_ticks()
			if self.np==0:
				self.frame=self.frame+self.fdir
			if self.frame==self.fnum:
				self.fdir=-1
			elif self.frame==0:
				self.fdir=1
		xs=self.aspace[0]*self.frame
		ys=animation*self.aspace[1]
		target.blit(self.pic,position,(xs,ys,self.aspace[0],self.aspace[1]))
class font:
	def __init__(self,bitmap):
		self.bmp=pygame.image.load(bitmap).convert()
		self.bmp.set_colorkey(self.bmp.get_at((0,0)))
		height=self.bmp.get_height()
		fstring="""! ! " # $ % & ' ( ) * + , - . / 0 1 2 3 4 5 6 7 8 9 : ; < = > ? @ A B C D E F G H I J K L M N O P Q R S T U V W X Y Z [ \ ] ^ _ ` a b c d e f g h i j k l m n o p q r s t u v w x y z { | } ~"""
		fstring=fstring.split(" ")
		self.letter_positions={}
		inletter=0
		for pixels in range(0,self.bmp.get_width()):
			#print self.bmp.get_at((pixels,0)),inletter
			if self.bmp.get_at((pixels,0))!=(255,0,255,255) and inletter==0:
				inletter=1
				start=pixels
			elif inletter==1 and self.bmp.get_at((pixels,0))==(255,0,255,255):
				try:
					char=fstring.pop(0)
					self.letter_positions[char]=(start,0,pixels-start,height)
					inletter=0
				except:
					inletter=0
	def draw_string(self,string,x,y,surface):
		for characters in string:
			if characters != " ":
				surface.blit(self.bmp,(x,y),self.letter_positions[characters])
				x=x+self.letter_positions[characters][2]
			else:
				x=x+self.letter_positions["~"][2]
class bullet:
	def __init__(self,parent,x,y,xdir):
		self.x=x
		self.y=y
		self.xdir=xdir
		self.picture=parent.bullet
		self.rect=self.picture.get_rect()
		self.screen=parent.screen
		self.target=parent.jedis[0]
		self.ground=parent.ground
		self.parent=parent
		self.dead=0
		self.ltime=0
		self.trect=pygame.rect.Rect(0,0,64,128)
	def update(self,camera):
		if pygame.time.get_ticks()-self.ltime>10:
			self.ltime=pygame.time.get_ticks()
			if self.dead==0:
				self.x=self.x+self.xdir
				tmprec=self.rect.move(self.x,self.y)
				#print tmprec,self.target.x,self.target.y
				if tmprec.collidelist(self.ground)!=-1:
					self.dead=1
				targrec=self.trect.move(self.target.x,self.target.y)
				if tmprec.colliderect(targrec)!=0:
					if self.parent.saber.np==1:
						self.target.hit()
						self.dead=1
					else:
						if self.target.lmove<0 and self.xdir < 0:
							self.xdir=-self.xdir
						elif self.target.lmove>0 and self.xdir < 0:
							self.xdir=-self.xdir
						else:
							self.target.hit()
							self.dead=1
							
				if self.x < 0:
					self.dead=1
		if self.dead==0:
			self.screen.blit(self.picture,(self.x-camera[0],self.y-camera[1]))
class stormtrooper:
	def __init__(self,parent,x,y):
		self.x=x
		self.y=y
		self.xdir=1
		self.ydir=0
		self.picture=parent.stormtrooper
		self.rect=pygame.rect.Rect(0,0,64,128)
		self.arrows=parent.arrows
		self.ground=parent.ground
		self.target=parent.jedis
		self.screen=parent.screen
		self.parent=parent
		self.ltime=0
		self.anim=0
		self.dying=0
		self.bullets=[]
		self.canfire=0
	def die(self):
		if self.dying==0:
			self.picture=animsprite(self.parent.tiles[1][0],(64,128),2,100)
			self.dying=1
			self.anim=self.anim+2
	def update(self,camera):
		if self.dying==0:
			self.target=self.parent.jedis[0]
			if pygame.time.get_ticks()-self.ltime>10:
				self.canfire=self.canfire+1
				colliderect=self.rect.move(self.x,self.y)
				self.ltime=pygame.time.get_ticks()
				if colliderect.collidelist(self.ground)==-1:
					self.y=self.y+1
				if colliderect.collidelist(self.arrows) !=-1:
					self.xdir=-self.xdir
					if self.xdir==1:
						self.anim=1
					else:
						self.anim=0
				self.x=self.x+self.xdir
				if abs(self.target.x - self.x)<600 and abs(self.target.y-self.y) < 128:
					if self.xdir==1:
						if self.target.x > self.x and self.canfire > 50:
							self.bullets.append(bullet(self.parent,self.x,self.y+36,self.xdir*4))
							self.canfire=0
					elif self.xdir==-1:
						if self.target.x < self.x and self.canfire > 50:
							self.canfire=0
							self.bullets.append(bullet(self.parent,self.x,self.y+36,self.xdir*4))
						
		else:
			if self.picture.frame==2:
				self.picture.np=1
		self.picture.animate((self.x-camera[0],self.y-camera[1]),self.anim,self.screen)
		for bullets in self.bullets:
			bullets.update(camera)
			if bullets.dead==1:
				self.bullets.pop(self.bullets.index(bullets))
class commando:
	def __init__(self,parent,x,y):
		self.x=x
		self.y=y
		self.picture=parent.commando
		self.rect=pygame.rect.Rect(0,0,64,128)
		self.ground=parent.ground
		self.target=parent.jedis
		self.screen=parent.screen
		self.platforms=parent.platforms
		self.parent=parent
		self.ltime=0
		self.anim=0
		self.dying=0
		self.bullets=[]
		self.canfire=0
		self.xdir=0
	def die(self):
		if self.dying !=1:
			self.picture=animsprite(self.parent.tiles[0][0],(64,128),3,40)
			self.picture.np=0
			self.dying=1
	def update(self,camera):
		if pygame.time.get_ticks()-self.ltime>10:
			self.target=self.parent.jedis[0]
			self.canfire=self.canfire+1
			if self.dying==0:
				flag=0
				colliderect=self.rect.move(self.x,self.y)
				for platforms in self.platforms:
					if colliderect.colliderect((platforms.x,platforms.y,128,64))==1:
						hit=self.platforms.index(platforms)
						flag=1
						self.x=self.x+platforms.xdir
				if colliderect.collidelist(self.ground)==-1 and flag==0:
					self.y=self.y+1
				if self.target.x < self.x:
					self.anim=0
					self.xdir=-4
				else:
					self.anim=1
					self.xdir=4
			else:
				if self.picture.frame==3:
					self.picture.np=1
			self.ltime=pygame.time.get_ticks()
			if self.canfire > 40 and self.dying==0:
				if abs(self.target.x-self.x) < 600 and abs(self.target.y-self.y) < 128:
					self.canfire=0
					self.bullets.append(bullet(self.parent,self.x,self.y+60,self.xdir*2))
		self.picture.animate((self.x-camera[0],self.y-camera[1]),self.anim,self.screen)
		for bullets in self.bullets:
			bullets.update(camera)
			if bullets.dead==1:
				self.bullets.pop(self.bullets.index(bullets))
class platform:			
	def __init__(self,parent,x,y):
		self.x=x
		self.y=y
		self.xdir=-1
		self.picture=parent.tiles[3][0]
		self.rect=pygame.rect.Rect(0,0,128,64)
		self.arrows=parent.arrows
		self.screen=parent.screen
		self.parent=parent
		self.ltime=0
		self.anim=0
	def update(self,camera):
		if pygame.time.get_ticks()-self.ltime > 10:
			self.ltime=pygame.time.get_ticks()
			colliderect=self.rect.move(self.x,self.y)
			hit=colliderect.collidelist(self.arrows)
			if hit!=-1:
				self.xdir=self.parent.arrowdirs[hit]
			self.x=self.x+self.xdir
		self.screen.blit(self.picture,(self.x-camera[0],self.y-camera[1]))
class jedi:
	def __init__(self,parent,x,y):
		self.x=x
		self.y=y
		self.picture=parent.jedi
		self.rect=pygame.rect.Rect(0,0,22,14)
		self.fullrect=pygame.rect.Rect(0,0,25,114)
		self.commandos=parent.commandos
		self.ground=parent.ground
		self.exits=parent.exits
		self.stormtroopers=parent.stormtroopers
		self.screen=parent.screen
		self.platforms=parent.platforms
		self.ewoks=parent.ewoks
		self.parent=parent
		self.ltime=0
		self.anim=1
		self.ydir=0
		self.playing=0
		self.health=20.0
		self.light=5
		self.lmove=0
		self.fpower=5.0
		self.swing=pygame.mixer.Sound("data/saber.wav")
	def hit(self):
		self.health=self.health-1
		if self.health <=0 :
			self.parent.loses()
	def draw_rect(self,rect2,camera):
		rect=rect2.move(-camera[0],-camera[1])
		#pygame.draw.polygon(self.screen,(255,0,0),((rect[0],rect[1]),(rect[0]+rect[2],rect[1]),(rect[0]+rect[2],rect[1]+rect[3]),(rect[0],rect[1]+rect[3])),1)
	def update(self,camera):
		if pygame.time.get_ticks()-self.ltime > 10:
			if self.fpower <= 5:
				self.fpower=self.fpower+.1*(6.0-self.light)
			if pygame.key.get_pressed()[K_ESCAPE]==1:
				self.parent.parent.mode=0
			if self.health < 20:
				self.health=self.health+.01*(1.0/self.light)
			flag=0
			self.ltime=pygame.time.get_ticks()
			collisionrect=self.rect.move(self.x+self.anim*41,self.y)
			if self.anim==0:
				hrect=self.fullrect.move(self.x+3,self.y)
			else:
				hrect=self.fullrect.move(self.x+35,self.y)
			self.draw_rect(hrect,camera)
			self.draw_rect(collisionrect,camera)
			for rects in self.ground:
				self.draw_rect(pygame.rect.Rect(rects),camera)
			hit=collisionrect.collidelist(self.ground)
			if hit!=-1:
				self.ydir=3
			collisionrect=self.rect.move(self.x+self.anim*41,self.y+114)
			hit=collisionrect.collidelist(self.ground)
			h2=hrect.collidelist(self.ground)
			for platforms in self.platforms:
				if collisionrect.colliderect((platforms.x,platforms.y,128,64))==1:
					hit=self.platforms.index(platforms)
					flag=1
					self.x=self.x+platforms.xdir
			if hit >=0:
				if flag==0:
					tmpy=self.ground[hit][1]-127.0
					if tmpy < self.y-25 or h2!=-1 and tmpy > self.y-25:
						self.x=self.x+self.lmove
					else:
						self.y=tmpy
				else:
					tmpy=self.platforms[hit].y-127.0
					if tmpy < self.y-30:
						self.x=self.x+self.lmove
					else:
						self.y=tmpy
				self.ydir=0
				if pygame.key.get_pressed()[K_UP]==1:
					self.ydir=-10
				elif pygame.key.get_pressed()[K_n]==1 and self.fpower>=5:
					self.ydir=-16
					self.fpower=-8
			else:
				if h2==-1:
					self.ydir=self.ydir+.3
				else:
					self.x=self.x+self.lmove
			self.y=self.y+self.ydir
			if pygame.key.get_pressed()[K_LEFT]==1:
				if self.lmove < 0:
					self.x=self.x-32
				self.x=self.x-(3-((5./self.light))/2.5)
				self.lmove=(3-((5./self.light))/2.5)
				self.anim=1
			elif pygame.key.get_pressed()[K_RIGHT]==1:
				if self.lmove > 0:
					self.x=self.x+32
				self.x=self.x+(3-((5./self.light))/2.5)
				self.lmove=-(3-((5./self.light))/2.5)
				self.anim=0
			if pygame.key.get_pressed()[K_m]==1 and self.fpower>=2.5 and self.parent.saber.np==1:
				self.parent.saber.np=0
				self.playing=9
				self.fpower=2.5
				self.swing.play()
			if self.parent.saber.np==0:
				self.playing=self.playing-1
				tmpr=pygame.rect.Rect(0,0,96,128)
				if self.anim==0:
					startx=self.x
				else:
					#startx=self.x-96
					startx=self.x
				tmpr=tmpr.move(startx,self.y)
				for commandos in self.commandos:
					#print commandos.x,commandos.y,commandos.rect.move(commandos.x,commandos.y),tmpr,tmpr.colliderect(commandos.rect.move(commandos.x,commandos.y))
					if tmpr.colliderect(commandos.rect.move(commandos.x,commandos.y))!=0:
						commandos.die()
				for commandos in self.stormtroopers:
					#print commandos.x,commandos.y,commandos.rect.move(commandos.x,commandos.y),tmpr,tmpr.colliderect(commandos.rect.move(commandos.x,commandos.y))
					if tmpr.colliderect(commandos.rect.move(commandos.x,commandos.y))!=0:
						commandos.die()
				for ewoks in self.ewoks:
					if tmpr.colliderect(ewoks.rect)!=0:
						ewoks.die()
						if self.light > 1:
							self.light=self.light-1
				if self.playing==0:
					self.parent.saber.np=1
					self.parent.saber.frame=0
			if collisionrect.collidelist(self.exits)!=-1:
					self.parent.wins()
			if self.y>480:
				self.health=0
				self.hit()
		self.picture.animate((self.x-camera[0],self.y-camera[1]),self.anim,self.screen)
		if self.anim==1:
			self.parent.saber.animate((self.x-camera[0]-50,self.y-camera[1]),self.anim,self.screen)
		else:
			self.parent.saber.animate((self.x-camera[0],self.y-camera[1]),self.anim,self.screen)
class ewok:
	def __init__(self,parent,x,y):
		self.pic=parent.tiles[12][0]
		self.x=x
		self.y=y
		self.alive=1
		self.rect=pygame.rect.Rect(0,0,64,116).move(self.x,self.y)
		self.screen=parent.screen
		self.parent=parent
	def die(self):
		self.parent.arttiles.append((self.parent.tiles[13][0],self.x,self.y))
		self.parent.ewoks.pop(self.parent.ewoks.index(self))
	def update(self,camera):
		self.screen.blit(self.pic,(self.x-camera[0],self.y-camera[1]))
class game:
	def __init__(self,parent,screen,levelnum):
		self.parent=parent
		self.screen=screen
		#Load the level data
		f=open("data/"+str(levelnum)+".lvl","r")
		self.ftiles=pickle.load(f)
		f.close()
		#Load tiles+images
		self.tiles=[]
		tiles=[]
		f=open("data/tiles","r")
		tdata=f.readlines()
		tdata.pop()
		#tdata=tdata.split()
		for items in tdata:
			items=items.strip()
			tiles.append(items.split())
		for tile in tiles:
			tmpimg=pygame.image.load(tile[0]).convert()
			if int(tile[2])==1:
				tmpimg.set_colorkey(tmpimg.get_at((0,0)))
			self.tiles.append((tmpimg,int(tile[1]),int(tile[3]),int(tile[4])))
		#Create our friendly stormtrooper and commando animation,warning, the commando image size may need doubling!!!!!!! All animations here
		self.saberpic=pygame.image.load("data/saber.png").convert()
		self.saberpic.set_colorkey(self.saberpic.get_at((0,0)))
	
		self.stormtrooper=animsprite(self.tiles[1][0],(64,128),2,100)
		self.commando=animsprite(self.tiles[0][0],(64,128),3,40)
		self.commando.np=1
		self.jedi=animsprite(self.tiles[11][0],(64,128),2,50)
		self.saber=animsprite(self.saberpic,(192,128),2,30)
		self.saber.np=1
		#Split all tiles into sections
		self.commandos=[]
		self.stormtroopers=[]
		self.ground=[]
		self.platforms=[]
		self.exits=[]
		self.jedis=[]
		self.arrows=[]
		self.arrowdirs=[]
		self.drawtiles=[]
		self.arttiles=[]
		self.ewoks=[]
		self.bullet=pygame.image.load("data/laser.png").convert()
		self.bullet.set_colorkey(self.bullet.get_at((0,0)))
		self.back=pygame.image.load("data/background.jpg").convert()
		self.hbar=pygame.image.load("data/health.png").convert()
		self.hbar.set_colorkey(self.hbar.get_at((0,0)))
		self.camera=[0,0]
		self.xdir=0.0
		self.win=pygame.image.load("data/win.jpg").convert()
		self.lose=pygame.image.load("data/loss.jpg")
		self.fmeter=pygame.image.load("data/fmeter.png").convert()
		self.levelnum=levelnum
		for tiles in self.ftiles:
			if tiles[0]==0:
				self.commandos.append(commando(self,tiles[1],tiles[2]))
			elif tiles[0]==1:
				self.stormtroopers.append(stormtrooper(self,tiles[1],tiles[2]))
			elif tiles[0]==2:
				self.exits.append(pygame.rect.Rect(tiles[1],tiles[2],128,48))
				self.drawtiles.append((self.tiles[2][0],tiles[1],tiles[2]))
			elif tiles[0]==3:
				self.platforms.append(platform(self,tiles[1],tiles[2]))
			elif tiles[0]==9:
				self.arrows.append((tiles[1],tiles[2],64,96))
				self.arrowdirs.append(1)
			elif tiles[0]==10:
				self.arrows.append((tiles[1],tiles[2],64,96))
				self.arrowdirs.append(-1)
			elif tiles[0]==11:
				self.jedis.append(jedi(self,tiles[1],tiles[2]))
			elif tiles[0]==7 or tiles[0]==6 or tiles[0]==5 or tiles[0]==4:
				self.ground.append((tiles[1],tiles[2],128,48))
				self.drawtiles.append((self.tiles[tiles[0]][0],tiles[1],tiles[2]))
			elif tiles[0]==12:
				self.ewoks.append(ewok(self,tiles[1],tiles[2]))
			else:
				self.arttiles.append((self.tiles[tiles[0]][0],tiles[1],tiles[2]))
		dfiles=["data/l5.png","data/l4.png","data/l3.png","data/l2.png","data/l1.png"]
		self.dimages=[]
		for items in dfiles:
			tmpimg=pygame.image.load(items).convert()
			tmpimg.set_colorkey(tmpimg.get_at((0,0)))
			self.dimages.append(tmpimg)
		if len(self.jedis)==0:
			self.parent.mode=0
	def update(self):
		if len(self.jedis) !=0:
			pygame.event.poll()
			if pygame.key.get_pressed()[K_w]==1:
				self.wins()
			#camera=(self.jedis[0].x-130,self.jedis[0].y-176)
			if self.jedis[0].x-self.camera[0] > 400:
				self.xdir=self.xdir+.1
			elif self.jedis[0].x-self.camera[0] < 100:
				self.xdir=self.xdir-.1
			self.camera[0]=self.camera[0]+self.xdir
			self.xdir=self.xdir/1.1
			if self.camera[0] < 0: self.camera[0]=0
			
			self.screen.blit(self.back,(0,0),(self.camera[0],0,640,480))
			if self.camera[0] > 4000-640:
				self.screen.blit(self.back,(-self.camera[0]+4000,0))
			for tiles in self.arttiles:
				self.screen.blit(tiles[0],(tiles[1]-self.camera[0],tiles[2]-self.camera[1]))
			for tiles in self.drawtiles:
				self.screen.blit(tiles[0],(tiles[1]-self.camera[0],tiles[2]-self.camera[1]))
			for commandos in self.commandos:
				commandos.update(self.camera)
			for troopers in self.stormtroopers:
				troopers.update(self.camera)
			for platforms in self.platforms:
				platforms.update(self.camera)
			for ewoks in self.ewoks:
				ewoks.update(self.camera)
			for jedis in self.jedis:
				jedis.update(self.camera)
			self.screen.blit(self.hbar,(30,450),(0,0,self.jedis[0].health*10,16))
			self.screen.blit(self.dimages[5-self.jedis[0].light],(550,400))
			if self.jedis[0].fpower > 0:
				self.screen.blit(self.fmeter,(240,450),(0,0,self.jedis[0].fpower*10,16))
			self.parent.font.draw_string("HEALTH",30,420,self.screen)
			self.parent.font.draw_string("FORCE POWER",240,420,self.screen)
			self.parent.font.draw_string("DARK-O-METER",400,380,self.screen)
	def wins(self):
		time.sleep(1)
		ltime=pygame.time.get_ticks()
		while pygame.time.get_ticks()-ltime < 2000:
			self.screen.blit(self.win,(0,0))
			if self.levelnum==10:
				self.parent.font.draw_string("YOU WIN!",300,400,self.screen)
			pygame.display.flip()
		self.parent.win()
	def loses(self):
		time.sleep(1)
		ltime=pygame.time.get_ticks()
		while pygame.time.get_ticks()-ltime < 2000:
			self.screen.blit(self.lose,(0,0))
			pygame.display.flip()
		self.parent.lose()
class editor:
	def __init__(self,parent,screen):
		self.screen=screen
		self.parent=parent
		self.tiles=[]
		self.icon_offset=0
		self.level_offset=0
		tiles=[]
		f=open("data/tiles","r")
		tdata=f.readlines()
		tdata.pop()
		#tdata=tdata.split()
		for items in tdata:
			items=items.strip()
			tiles.append(items.split())
		for tile in tiles:
			tmpimg=pygame.image.load(tile[0]).convert()
			if int(tile[2])==1:
				tmpimg.set_colorkey(tmpimg.get_at((0,0)))
			self.tiles.append((tmpimg,int(tile[1]),int(tile[3]),int(tile[4])))
		self.grid=pygame.image.load("data/editgrid.png")
		self.grid.set_colorkey(self.grid.get_at((0,0)))
		self.tick=0
		self.ltime=0
		self.msize=0
		self.chosen_tile=self.tiles[0]
		self.ltiles=[]
		self.ftiles=[]
		self.utiles=[]
		self.mode=0
		self.ncal=None
		self.prompt=""
		self.input=""
		self.lchar=""
		self.lnum=0
		self.font=font("data/bfont.png")
	def update(self):
		grid_offset=-(self.level_offset-((int(self.level_offset)/64)*64))
		pygame.event.poll()
		self.screen.fill((255,0,0))
		self.screen.blit(self.grid,(grid_offset,0))
		#Draw the level tiles
		for tiles in self.ftiles:
			self.screen.blit(self.tiles[tiles[0]][0],(tiles[1]-self.level_offset,tiles[2]),(0,0,self.tiles[tiles[0]][2],self.tiles[tiles[0]][3]))
		#Draw the tiles out
		self.ltiles=[]
		cx=0
		for tile in self.tiles:
			if tile[2]==64:
				self.screen.blit(tile[0],(cx-self.icon_offset,432),(0,0,64,48))
				self.ltiles.append((tile,cx-self.icon_offset,432,cx-self.icon_offset+64,480))
				cx=cx+74
			elif tile[2]==128:
				self.screen.blit(tile[0],(cx-self.icon_offset,432),(0,0,128,48))
				self.ltiles.append((tile,cx-self.icon_offset,432,cx-self.icon_offset+128,480))
				cx=cx+138
		self.msize=cx
		#Draw the mouse with its chosen tile:
		pos=pygame.mouse.get_pos()
		self.screen.blit(self.chosen_tile[0],pos,(0,0,self.chosen_tile[2],self.chosen_tile[3]))
		#Update the updater:
		if pygame.time.get_ticks()-self.ltime > 10:
			self.tick=1
			self.ltime=pygame.time.get_ticks()
		#Do the mouse
		pos=pygame.mouse.get_pos()
		if self.tick==1 and self.mode==0:
			self.tick=0
			if pygame.key.get_pressed()[K_ESCAPE]==1:
				self.parent.mode=0
			if pygame.key.get_pressed()[K_s]==1:
					f=open("data/"+str(self.lnum)+".lvl","w")
					pickle.dump(self.ftiles,f)
					f.close()
					f=open("data/"+str(self.lnum)+".lvl","r")
					self.ftiles=pickle.load(f)
					f.close()
					print "LEVEL SAVED"
			if pygame.key.get_pressed()[K_KP_PLUS]==1:
				f=open("data/"+str(self.lnum)+".lvl","w")
				pickle.dump(self.ftiles,f)
				f.close()
				self.lnum=self.lnum+1
				try:
					f=open("data/"+str(self.lnum)+".lvl","r")
					self.ftiles=pickle.load(f)
					f.close()
				except:
					self.ftiles=[]
				self.ltime=self.ltime+300
			elif pygame.key.get_pressed()[K_KP_MINUS]==1:
				f=open("data/"+str(self.lnum)+".lvl","w")
				pickle.dump(self.ftiles,f)
				f.close()
				self.lnum=self.lnum-1
				try:
					f=open("data/"+str(self.lnum)+".lvl","r")
					self.ftiles=pickle.load(f)
					f.close()
				except:
					self.ftiles=[]
				self.ltime=self.ltime+300
			if pygame.mouse.get_pressed()[2]==1:
				pygame.mouse.set_pos((int(pos[0])/64)*64,(int(pos[1])/48)*48)
			if pygame.key.get_pressed()[K_z]==1:
				if len(self.ftiles):
					self.utiles.append(self.ftiles.pop())
					self.ltime=self.ltime+30
			elif pygame.key.get_pressed()[K_x]==1:
				if len(self.utiles):
					self.ftiles.append(self.utiles.pop())
					self.ltime=self.ltime+30
			if pos[1] > 432:
				if pos[0] < 30:
					self.icon_offset=self.icon_offset-5
				elif pos[0] > 610:
					self.icon_offset=self.icon_offset+5
				if self.icon_offset < 0:
					self.icon_offset=0
				elif self.icon_offset > self.msize-640:
					self.icon_offset=self.msize-640
				
				if pygame.mouse.get_pressed()[0]==1:
					for tiles in self.ltiles:
						if pos[0] > tiles[1] and pos[0] < tiles[3]:
							self.chosen_tile=tiles[0]
			else:
				if pos[0] < 30:
					self.level_offset=self.level_offset-5
				elif pos[0] > 610:
					self.level_offset=self.level_offset+5
				if self.level_offset < 0:
					self.level_offset=0
				
				if pygame.mouse.get_pressed()[0]==1:
					self.ftiles.append((self.chosen_tile[1],pos[0]+self.level_offset,pos[1]))
					self.ltime=self.ltime+100
				if pygame.mouse.get_pressed()[1]==1:
					self.level_offset=(int(self.level_offset)/64)*64
		self.font.draw_string("LEVEL: "+str(self.lnum),10,10,self.screen)
	def savemap(self):
		print self.input
class menu:
	def __init__(self,screen):
		self.music=pygame.mixer.Sound("data/music.ogg")
		self.screen=screen
		self.editor=editor(self,screen)
		self.font=font("data/bfont.png")
		self.selection=0
		self.menuitems=["Play","Level Editor","Instructions","Fullscreen","Exit"]
		self.events=[self.play,self.leveledit,self.instruct,self.fullscreen,sys.exit]
		self.back=pygame.image.load("data/menu.png").convert()
		self.cursor=pygame.image.load("data/cursor.png").convert()
		self.cursor.set_colorkey(self.cursor.get_at((0,0)))
		self.ltime=0
		self.mode=0
		self.level=1
		self.music.play()
		self.starfield=pygame.image.load("data/starfield.jpg").convert()
		
		self.insttext="""Welcome to Dark Side
		You are Johnny Smith, the last 
		remaining Jedi Knight in
		the fight against the empire!
		If you are destroyed, the galaxy will
		be doomed forever.  You must
		fight your way through
		Imperial bases.
		
		You can walk and jump using the
		arrow keys.  To do an ultra high
		force aided jump, uses the 'n' key.
		To swing your lightsaber, hit 'm'.
		Force aided jumps and lightsaber
		swings use force energy.  After
		performing them, you must wait
		for your force energy to
		recharge.
		
		Watch out for Storm Troopers
		and enemy commandos.  As you
		go through each base, you
		may encounter Ewoks.
		If you kill them, you will
		slowly turn to the
		dark side, so be careful.
		
		The closer to the Dark Side
		that you get, the faster
		you gain health, as you use
		Super Secret Sith Lord Techniques(tm).
		Also, your force powers recharge
		faster while on the dark side.
		A weight on your shoulders, the dark
		side is.  Slow you down it will!
		
		To exit a base (and move on to
		the next one), you must find
		the Radio-Teleport.  
		Onceyou arrive at it, it will beam you
		out of the base.  Enjoy your day."""
		self.insttext=self.insttext.split("""\n""")
	def play(self):
		self.level=1
		self.game=game(self,screen,1)
		self.mode=1
	def leveledit(self):
		self.mode=2
	def instruct(self):
		self.ins=[]
		y=400
		for lines in self.insttext:
			lines=lines.strip()
			self.ins.append([lines.strip(),y])
			y=y+30
		self.mode=3
		self.camera=0
	def instructions(self):
		self.screen.blit(self.starfield,(0,0))
		for lines in self.ins:
			self.font.draw_string(lines[0],10,lines[1]-self.camera,self.screen)
		if self.ins[-1][1]-self.camera < 10:
			self.mode=0
		if pygame.time.get_ticks()-self.ltime > 10:
			self.ltime=pygame.time.get_ticks()
			self.camera=self.camera+1
	def fullscreen(self):

		if self.menuitems[3]=="Fullscreen":
			self.menuitems[3]="Windowed"
			print "w"
			self.screen=pygame.display.set_mode((640,480),FULLSCREEN)
		elif self.menuitems[3]=="Windowed":
			self.menuitems[3]="Fullscreen"
			print "f"
			self.screen=pygame.display.set_mode((640,480))
		else:
                    print self.menuitems[3]
	def update(self):
		if pygame.mixer.get_busy()==0:
			self.music.play()
		if self.mode==0:
			self.menu()
		elif self.mode==1:
			self.game.update()
		elif self.mode==2:
			self.editor.update()
		elif self.mode==3:
			self.instructions()
		pygame.display.flip()
	def win(self):
		self.level=self.level+1
		self.game=game(self,screen,self.level)
	def lose(self):
		self.game=game(self,screen,self.level)
	def menu(self):
		self.screen.blit(self.back,(0,0))
		cy=150
		for items in self.menuitems:
			self.font.draw_string(items,100,cy,self.screen)
			cy=cy+70
		self.screen.blit(self.cursor,(30,self.selection*70+120))
		if pygame.time.get_ticks()-self.ltime>100:
			pygame.event.poll()
			self.ltime=pygame.time.get_ticks()
			if pygame.key.get_pressed()[K_UP]==1:
				self.selection=self.selection-1
			elif pygame.key.get_pressed()[K_DOWN]==1:
				self.selection=self.selection+1
			if self.selection < 0:
				self.selection=len(self.menuitems)-1
			elif self.selection > len(self.menuitems)-1:
				self.selection=0
			if pygame.key.get_pressed()[K_RETURN]==1:
				self.events[self.selection]()

				
pygame.init()
screen=pygame.display.set_mode((640,480))
pygame.display.set_caption("Dark Side - By CrazyNorman")
#e=editor(screen)
m=menu(screen)
while 1==1:
	m.update()
